from zhipuai import ZhipuAI

zhipuai_client = ZhipuAI(api_key="041ee4d3096b1dbb5c05733469c8456f.L2KsmLf3Cvq1JfYi")  # 填写您自己的APIKey

def get_chat(prompt,
             system=None,
             history=None,
             max_length=2048,
             top_p=0.7,
             temperature=0.95,
             model_name='glm-4'):

    temp_messages = []

    if system is not None and len(system) > 0:
        system_message = {"role": "system", "content": system}
        # 将用户输入添加到messages中
        temp_messages.append(system_message)

    if history is not None:
        for item in history:
            temp_messages.append(item)

    user_message = {"role": "user", "content": prompt}
    # 将用户输入添加到messages中
    temp_messages.append(user_message)

    # 创建一个 GPT-3 请求
    response = zhipuai_client.chat.completions.create(
        model=model_name,
        messages=temp_messages
    )

    robot_message = response.choices[0].message.content

    # print('【openai调用结果】\t', robot_message)
    return robot_message


def get_stream_chat(prompt,
                    system=None,
                    history=None,
                    max_length=2048,
                    top_p=0.7,
                    temperature=0.95,
                    model_name='glm-4'):
    temp_messages = []

    if system is not None and len(system) > 0:
        system_message = {"role": "system", "content": system}
        # 将用户输入添加到messages中
        temp_messages.append(system_message)

    if history is not None:
        for item in history:
            temp_messages.append(item)

    user_message = {"role": "user", "content": prompt}
    # 将用户输入添加到messages中
    temp_messages.append(user_message)

    # 创建一个 GPT-3 请求
    response = zhipuai_client.chat.completions.create(
        model=model_name,
        messages=temp_messages,
        stream=True
    )

    robot_message = ''
    for chunk in response:
        robot_message += chunk.choices[0].delta.content
        yield robot_message

if __name__ == '__main__':
    prompt = '你好'
    test_result = get_chat(prompt)
    print(test_result)